Subject: Re: bug#70901: 30.0.50; Tramp doesn't use ControlMaster even with (setq tramp-use-connection-share nil)

From: Dmitry Gutov <[email-masked]>
Date: Sun, 19 May 2024 03:07:35 +0300

On 18/05/2024 20:47, Michael Albinus wrote:
> Dmitry Gutov <[email-masked]> writes:
> 
> Hi Dmitry,
> 
>> Do you perhaps see a way to change messaging (to the echo area) that
>> would remove the impression that the connection is still being
>> established after it has already been established (and we're in the
>> process of additional Tramp connection initialization)?
> 
> Tramp messages are grouped in different levels. If we want more
> fine-grained information, the respective message should have a higher
> level. Tramp is thrifty with level 3 messages.
> 
> However, per default Tramp shows only messages up to level 3. A message
> with a higher level wouldn't be seen by the majority of the users.
> 
> What if we document the meaning of the "Opening connection ..." message
> instead? Something like

It's probably an improvement.

But I haven't read the entirely of the Tramp manual myself, so this 
section, however well-written, likely wouldn't have helped me.

Here's two potential alternatives:

1. Somehow have a message that only spans the time the connection is 
established, and don't print the rest by default (the user will note 
when the action finished anyway, and there likely will be other messages 
corresponding to different operations - copying a file, opening it, 
etc). I'm not sure how to fit that into the described framework, but 
what if the new message was level 3 and the current was moved to level 4?

2. Change the current text's message so it doesn't say "Opening 
connection" but refers to something more complex like "Connection 
finalization" - that one still not very specific, perhaps you'll have a 
better idea?

1 implies 2, but they might also be combined.

> diff --git a/doc/misc/tramp.texi b/doc/misc/tramp.texi
> index d1c58d83aeb..45be1e27931 100644
> --- a/doc/misc/tramp.texi
> +++ b/doc/misc/tramp.texi
> @@ -2940,6 +2940,13 @@ Ssh setup
>   set to @code{t} or @code{suppress}, @command{plink} is called with the
>   option @option{-share} or @option{-noshare}, respectively.
> 
> +@strong{Note} that the @value{tramp} message @samp{Opening connection
> +...} in the echo area spans not only the time until @command{ssh} or
> +@command{plink} return the echo prompt.  It includes also the time for
> +initialization @value{tramp} performs on the remote host.  Therefore,
> +the effect of the @code{tramp-use-connection-share} setting isn't
> +determined by this time period completely.
> +
> 
>   @subsection Configure direct copying between two remote servers
> 
> 
> 
> Best regards, Michael.